Loading...
Searching...
No Matches
rational.h File Reference
libavutil » Mathematics » AVRational

Utilties for rational number calculation. More...

`#include <stdint.h>`
`#include <limits.h>`
`#include "attributes.h"`

Go to the source code of this file.

## Data Structures

struct | AVRational
| Rational number (pair of numerator and denominator). More...

## Functions

static AVRational | av_make_q (int num, int den)
| Create an AVRational.
static int | av_cmp_q (AVRational a, AVRational b)
| Compare two rationals.
static double | av_q2d (AVRational a)
| Convert an AVRational to a `double`.
int | av_reduce (int *dst_num, int *dst_den, int64_t num, int64_t den, int64_t max)
| Reduce a fraction.
AVRational | av_mul_q (AVRational b, AVRational c) av_const
| Multiply two rationals.
AVRational | av_div_q (AVRational b, AVRational c) av_const
| Divide one rational by another.
AVRational | av_add_q (AVRational b, AVRational c) av_const
| Add two rationals.
AVRational | av_sub_q (AVRational b, AVRational c) av_const
| Subtract one rational from another.
static av_always_inline AVRational | av_inv_q (AVRational q)
| Invert a rational.
AVRational | av_d2q (double d, int max) av_const
| Convert a double precision floating point number to a rational.
int | av_nearer_q (AVRational q, AVRational q1, AVRational q2)
| Find which of the two rationals is closer to another rational.
int | av_find_nearest_q_idx (AVRational q, const AVRational *q_list)
| Find the value in a list of rationals nearest a given reference rational.
uint32_t | av_q2intfloat (AVRational q)
| Convert an AVRational to a IEEE 32-bit `float` expressed in fixed-point format.
AVRational | av_gcd_q (AVRational a, AVRational b, int max_den, AVRational def)
| Return the best rational so that a and b are multiple of it.

## Detailed Description

Utilties for rational number calculation.

Author
  Michael Niedermayer micha.nosp@m.elni.nosp@m.@gmx..nosp@m.at

Definition in file rational.h.